% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR

function [b,a] = shanksmet(hd,M,N)
% Proiectarea unui filtru prin metoda Shanks
% Parametrii:
%  hd = raspunsul la impuls dorit
%  M = gradul numaratorului
%  N = gradul numitorului
% Iesire:
%  b = coeficientii numaratorului
%  a = coeficientii numitorului


% Vectorul a este obtinut prin metoda celor mai mici patrate (sau Prony,
% acesta il obtine tot prin aceasta metoda)
a = lsinv(hd,N);
v = impz(1,a);

% Se foloseste vectorul a dat de Prony
% [bp,ap] = prony(hd,M,N);
% a = ap;
% v = impz(1,ap);  % Impulse response of all-pole filter

% Calcul Rvv
rvv = xcorr(v);
row = rvv(length(v):length(v)+M);
R = toeplitz(row,row);

% Calcul rhv
rhv = xcorr(hd,v);
K = max(length(hd),length(v));
r = rhv(K:K+M);

% Rezolvare sistem
b = inv(R)*r;
